<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Teknisa\MAN\Services\ConfigMesaAmbienteService;
use Zeedhi\Framework\DTO\Response\Notification;

class ConfigAmbienteController extends \Teknisa\MAN\Controllers\TeknisaCrud  {

    const AMBIENTE_DATASOURCE = 'vnd56000_configmesaambiente';
    
    protected $dataSourceName = ConfigAmbienteController::AMBIENTE_DATASOURCE;
    protected $ConfigMesaAmbienteService;
    protected $crudService;

    public function __construct ($crudService, $ConfigMesaAmbienteService) {
        $this->crudService = $crudService;
        $this->ConfigMesaAmbienteService = $ConfigMesaAmbienteService;
    }
    
    public function saveAmbiente(DTO\Request\DataSet $request, DTO\Response $response) {
        foreach($request->getDataSet()->getRows() as $key => &$row) {
            $row['IDATIVO'] = 'S';
            if($row['__is_new'] && (!isset($row['CDSALA']) || !is_int($row['CDSALA']))) {
                $row['CDSALA'] = $this->ConfigMesaAmbienteService->getNextCodigo($row['CDFILIAL']);
                $row['CDSALA'] = sprintf("%05d", $row['CDSALA']);
            }
        }
		$rows = $this->crudService->getRowsToSave($request, $this->dataSourceName);
        parent::save($request,$response);
        $response->addDataSet(new DataSet($this->dataSourceName, $rows));
    }
	
	public function deleteWithoutNotification (DTO\Request\DataSet $request, DTO\Response $response) {
		try {
            $dataSet = $request->getDataSet();
            $dataSet->setDataSourceName($this->dataSourceName);
            $deletedRows = $this->crudService->delete($response, $dataSet);
            $nrDeletedRows = 0;
            if(is_array($deletedRows)){
                $nrDeletedRows = count($deletedRows);
            }
            
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
	}
    
}