<?php

namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Teknisa\MAN\Utilities;


//use Zeedhi\Framework\DataSource\FilterCriteria;

class RelDescConcedidosCallCenter extends CrudWithParameterBag{

    const Relatorio = 'vnd55010_relDescConcedidosCall';
    
    protected $parameterBagColumns = array('CDFILIAL', 'DATAINI', 'DATAFIN');
    protected $relDescService;
    protected $utilService;
    protected $dataSourceName;
    
    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag, Utilities\Util $utilService) {
        parent::__construct($dataSourceManager, $parameterBag);
        $this->utilService = $utilService;
    }
    
    
    public function relDescontocall(DTO\Request\Filter $request, DTO\Response $response) {
            $conditions = $this->utilService->getParamsAsArray($request);
            $this->conditionsMake($conditions);
            $dataSourceFilter = array();
            $this->dataSourceName = self::Relatorio;
            
            
             foreach($conditions as $key => $value) {
                $dataSourceFilter[] = array(
                    "columnName" => $key,
                    "operator"=> "=",
                    "value"=> $value
                );
            }
            
            for($i = 0; $i < count($conditions); $i++) {
                if(strpos($dataSourceFilter[$i]["columnName"], '|') != false) {
                    $dataSourceFilter[$i]["operator"] = "MAPPED_LIKE_ALL";
                }
            }
            
            $newRequest = new DTO\Request\Filter(
                new FilterCriteria(
                    $this->dataSourceName,
                    $dataSourceFilter,
                    $request->getFilterCriteria()->getPage(),
                    $request->getFilterCriteria()->getPageSize()
                ),
                $request->getMethod(),
                $request->getRoutePath(),
                $request->getUserId()
            );
            
            parent::find($newRequest, $response);
    }
    
    public function conditionsMake(&$conditions){
       if (isset($conditions['DTENTRVENDA'])){
            $conditions['DATAINI'] = $conditions['DTENTRVENDA'][0];
            $conditions['DATAFIN'] = $conditions['DTENTRVENDA'][1];
            unset($conditions['DTENTRVENDA']);
       }
       
    }
}